import os, sys
sys.path.append('/Users/Fer/root/build/lib')
import ROOT as root
from ROOT import TFile, TIter, TKey, gROOT, TColor

def getTiterLen(keyList): #since I can't find with TIter method gives me it's size I'll invent it
    tO = root.TObjArray()
    test = TIter(tO)
    if type(keyList) != type(test):
        return 'This is not a TIter'
    n = 0
    for key in keyList:
        n = n + 1
    return n

def getFileLen(rootFile):
    keyList = TIter(rootFile.GetListOfKeys())
    return getTiterLen(keyList)

def addHistograms(directory='/Users/Fer/oceanview', rootFile = 'rawHistograms', saveAs = 'addedHistograms'):
    os.chdir(directory)
    infile = TFile.Open(rootFile + '.root') #read root file with histograms
    keyList = TIter(infile.GetListOfKeys()) #generate pointers to the histograms
    h0 = keyList.Begin().ReadObj()
    h = root.TH1F('addedHistograms','Added Histograms',h0.GetNbinsX(),h0.GetXaxis().GetXmin(),h0.GetXaxis().GetXmax())
    print 'sumando'
    for key in keyList: #loop through histograms adding them up
        cl = gROOT.GetClass(key.GetClassName()) #if something there is not a histogram, ignore it
        if (not cl.InheritsFrom("TH1")):
            continue
        h = h + key.ReadObj() #add histograms
        print h.GetEntries()
    outfile = root.TFile(saveAs + '.root', 'recreate') #create file for the final product
    h.Write() #save it
    print h.GetEntries()

def subtractNoise(directoryNoise,noiseFile,directoryData,rawDataFile,dataFile):
    os.chdir(directoryNoise)
    infile = TFile.Open(noiseFile+'.root')
    keyList = TIter(infile.GetListOfKeys())
    hNoise = keyList.Begin().ReadObj()
    print 'noise entries'
    print hNoise.GetEntries()
    hNoise.SetDirectory(root.gROOT)
    os.chdir(directoryData)
    infile = TFile.Open(rawDataFile+'.root')
    n = getFileLen(infile)
    infile = TFile.Open(dataFile+'.root')
    keyList = TIter(infile.GetListOfKeys())
    hHist = keyList.Begin().ReadObj()
    print 'data entries'
    print hHist.GetEntries()
    hHist.Add(hHist,hNoise,1.0,-1.0*n)
    print 'after noise subtraction'
    print hHist.GetEntries()
    outfile = root.TFile('finalResult.root', 'recreate')
    hHist.Write()

directoryData = '/Users/Fer/Desktop/testtest/paintFiber copy'
directoryNoise = '/Users/Fer/Desktop/testtest/paintFiber copy/noise'
noiseFile = 'finalNoise'
dataFile = 'addedHistograms'
rawDataFile = 'rawHistograms'
addHistograms(directoryData)
subtractNoise(directoryNoise,noiseFile,directoryData,rawDataFile,dataFile)

directoryData = '/Users/Fer/Desktop/testtest/paintLED copy'
directoryNoise = '/Users/Fer/Desktop/testtest/paintLED copy/noise'
noiseFile = 'finalNoise'
dataFile = 'addedHistograms'
rawDataFile = 'rawHistograms'
addHistograms(directoryData)
subtractNoise(directoryNoise,noiseFile,directoryData,rawDataFile,dataFile)